#!/usr/bin/python

from padadapter import PadAdapter
from pad import LedButton, LedCtrlButton
from simplemidi.options import *

class APCMini(PadAdapter):
	
	_DEFAULT_PARAMS={
		'name': 'Simple Midi AKAI APC Mini',
		'autoconnect_in': 'APC MINI:APC MINI MIDI',
		'autoconnect_out': 'APC MINI:APC MINI MIDI'
	}
	
	def __init__(self, param={}):
		PadAdapter.__init__(self, initParams(APCMini._DEFAULT_PARAMS, param))
			
			
		
	def onAdapt(self, pad):
		pad.ledbuttonsWidth=8
		pad.ledbuttonsHeight=8
		
		for i in range(pad.ledbuttonsHeight):
			for j in range(pad.ledbuttonsWidth):
				pad.ledbuttons[j+i*pad.ledbuttonsWidth]=LedButton(pad.oport, j+i*pad.ledbuttonsWidth)
		
		for i in range(64, 72):
			pad.ledbuttons[i]=LedCtrlButton(pad.oport, i)
			
		for i in range(82, 90):
			pad.ledbuttons[i]=LedCtrlButton(pad.oport, i)
		pad.ledbuttons[98]=LedButton(pad.oport, i)	
		
		for i in pad.ledbuttons.keys():
			pad.input[i]=0
		
		#pad.clear()
		
