#!/usr/bin/python

from serpentgame import SerpentAPCMini, setRealtime
from apcmini import APCMini
from paintpad import PaintPad
from simplemidi.midiio import MidiInputPort, MidiOutputPort
from simplemidi.midiplayer import MidiPlayer
from padhelper import PadHelper
from syncpadhelper import SyncPadHelper
from simplemidi.alsaconnector import AlsaConnector
import time
import sys
import rtmidi
from simplemidi.options import *
from simplemidi.midieventtrigger import *
import compose.midicompose

#path="/home/fanch/Documents/tabs/Misc Children - Twinkle Twinkle Little Star2.mid"
#path="/home/fanch/Documents/tabs/Johann Pachelbel - Canon In D (ver 6 by Ezechiel).mid"
path="/home/fanch/Documents/tabs/Misc Traditional - Katyusha.mid"
#path="/home/fanch/Documents/tabs/JerryC - Canon Rock.mid"
"""
if __name__=="__main__":	
	#
	m=MidiPlayer(path)
	m.setBpmRatio(1)
	m.transpose(-12)
	input("Press Enter to continue...")
	#m.connect((28,0))
	m.play()
"""
def _test_midiPlayer():
	m=MidiPlayer(path,{})
	m.setBpmRatio(1)
	m.transpose(48)
	input("...")
	m.play()


def _test_syncPadHelper():
	m = SyncPadHelper(APCMini(), path, {
		'transpose': 24,
		'pad_translate' : -24
		
	})
	m.setBpmRatio(1)
	m.setPadTrack(1)
	input("...")
	m.play()

def _test_padHelper():
	m = PadHelper(APCMini(), path, {})
	m.setBpmRatio(1)
	m.setPadTrack(1)
	m.setPadTranslate(0)
	m.transpose(0)
	input("...")
	m.play()

def _test_paintPad():
	apc=APCMini()

	jeu=PaintPad(apc, {})
	jeu.start()

def _test_serpent():
	apc=APCMini()
	#setRealtime()
	jeu = SerpentAPCMini(apc)
	jeu.waitForInput()
	jeu.loadingScreen(2)
	jeu.start()
	jeu.close()

			
def testCb(x, y):
	print("Trigger : ", x)

def testTrigger():
	t=MidiMultiTrigger()
	ip=MidiInputPort({'port_name': 'In'})
	ip.open()
	ip.connect((28,0))
	
	op=MidiInputPort({'port_name': 'Out'})
	op.open()
	op.connect((28,0))
	t.addTrigger(1, (MidiEventTrigger.NOTE, (16,32), None, False))
	
	while True:
		evt=ip.getSync()
		print(t.filter(evt, op))
		

if __name__=="__main__":	
	n=6
	if len(sys.argv)>1: n=int(sys.argv[1])
	
	if n==0: testTrigger()
	if n==1: _test_syncPadHelper()
	if n==2: _test_padHelper()
	if n==3: _test_midiPlayer()
	if n==4: _test_paintPad()
	if n==5: _test_serpent()
	if n==5: _test_compose()
