
from simplemidi.midiplayer import MidiPlayer, _Event, sortTime
from simplemidi.midiio import MidiOutputPort
from simplemidi.midimessage import MidiType, MidiMessage, NoteOn, NoteOff, MidiVoiceMessage
from pad import Pad
from simplemidi.options import *
import time
from simplemidi.midieventtrigger import *


class PadLighter(Pad):
    _DEFAULT_PARAMS = dictAssign(Pad._DEFAULT_PARAMS, {
                                     'port_in': {
                                         'client_name': 'Pad Helper',
                                         'port_name': 'Pad In'
                                     },
                                     'port_out': {
                                         'client_name': 'Pad Helper',
                                         'port_name': 'Pad Out'
                                     },
                                     'port_sound_out': {
                                         'client_name': 'MidiPlayer'
                                     },
                                     'pad_track': -1,
                                     'pad_translate': 0,
                                     'n_color': 1

                                 })

    def __init__(self, adapter, params):
        param=initParams(PadLighter._DEFAULT_PARAMS, params)
        Pad.__init__(self, adapter, param)
        self.sound=MidiOutputPort.fromParams(param['port_sound_out'])
        self.sound.open()


